from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import File, String, Int, Boolean

Assaygeneratormetabo_V0_1_0 = CommandToolBuilder(tool="AssayGeneratorMetabo", base_command=["AssayGeneratorMetabo"], inputs=[ToolInput(tag="in_in", input_type=File(optional=True), prefix="-in", doc=InputDocumentation(doc="*                            MzML Input file (valid formats: 'mzml')")), ToolInput(tag="in_in_id", input_type=File(optional=True), prefix="-in_id", doc=InputDocumentation(doc="*                         FeatureXML Input with id information (accurate mass search) (valid formats: 'featurexml')")), ToolInput(tag="in_out", input_type=File(optional=True), prefix="-out", doc=InputDocumentation(doc="*                           Assay library output file (valid formats: 'tsv')")), ToolInput(tag="in_method", input_type=String(optional=True), prefix="-method", doc=InputDocumentation(doc="(default: 'highest_intensity' valid: 'highest_intensity', 'consensus_spectrum')")), ToolInput(tag="in_precursor_mz_tolerance", input_type=Int(optional=True), prefix="-precursor_mz_tolerance", doc=InputDocumentation(doc="Tolerance window for precursor selection (Feature selection in regard to the precursor) (default: '0.005')")), ToolInput(tag="in_precursor_mz_tolerance_unit", input_type=String(optional=True), prefix="-precursor_mz_tolerance_unit", doc=InputDocumentation(doc="Unit of the precursor_mz_tolerance (default: 'Da' valid: 'Da', 'ppm')")), ToolInput(tag="in_precursor_mz_distance", input_type=Int(optional=True), prefix="-precursor_mz_distance", doc=InputDocumentation(doc="Max m/z distance of the precursor entries of two spectra to be merged in [Da]. (default: '0.0001')")), ToolInput(tag="in_precursor_rt_tolerance", input_type=Int(optional=True), prefix="-precursor_rt_tolerance", doc=InputDocumentation(doc="Tolerance window (left and right) for precursor selection [Da] (default: '5')")), ToolInput(tag="in_cosine_similarity_threshold", input_type=Int(optional=True), prefix="-cosine_similarity_threshold", doc=InputDocumentation(doc="Threshold for cosine similarity of MS2 spectras of same precursor used for consensus spectrum (default: '0.98')")), ToolInput(tag="in_filter_by_convex_hulls", input_type=Int(optional=True), prefix="-filter_by_convex_hulls", doc=InputDocumentation(doc="Features have to have at least x MassTraces (default: '2')")), ToolInput(tag="in_transition_threshold", input_type=Int(optional=True), prefix="-transition_threshold", doc=InputDocumentation(doc="Further transitions need at least x% of the maximum intensity (default 10%) (default: '10')")), ToolInput(tag="in_use_known_unknowns", input_type=Boolean(optional=True), prefix="-use_known_unknowns", doc=InputDocumentation(doc="Use features without identification information")), ToolInput(tag="in_ini", input_type=File(optional=True), prefix="-ini", doc=InputDocumentation(doc="Use the given TOPP INI file")), ToolInput(tag="in_threads", input_type=Int(optional=True), prefix="-threads", doc=InputDocumentation(doc="Sets the number of threads allowed to be used by the TOPP tool (default: '1')")), ToolInput(tag="in_write_ini", input_type=File(optional=True), prefix="-write_ini", doc=InputDocumentation(doc="Writes the default configuration file")), ToolInput(tag="in_helphelp", input_type=Boolean(optional=True), prefix="--helphelp", doc=InputDocumentation(doc="Shows all options (including advanced)"))], outputs=[ToolOutput(tag="out_out", output_type=File(optional=True), selector=InputSelector(input_to_select="in_out", type_hint=File()), doc=OutputDocumentation(doc="*                           Assay library output file (valid formats: 'tsv')"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Assaygeneratormetabo_V0_1_0().translate("wdl", allow_empty_container=True)

